<?php

use Snaju\Inception\Http\Message\FlashMessage;
use Snaju\Inception\Http\Request\Controller;
use Snaju\Inception\Http\Response\Response;
use Snaju\Inception\Http\Response\ResponseHandler;
use Snaju\Inception\Settings\Config;

// TODO: add checks to make sure function doesn't exists using these reserved keywords. throw exception if they do or remove and override them. Check with Zack

if (! function_exists('render')) {
    function render(...$args): string
    {
        return ResponseHandler::getInstance()->render(...$args);
    }
}

if (! function_exists('response')) {
    function response(): ResponseHandler
    {
        return ResponseHandler::getInstance();
    }
}

if (! function_exists('config')) {
    // TODO: add secondary argument to set and return the key if it doesn't exist
    function config($key): ?string
    {
        return Config::get($key);
    }
}

if (! function_exists('env')) {
    // TODO: add secondary argument to set and return the key if it doesn't exist
    function env($key): ?string
    {
        if (isset($_ENV[$key])) {
            return $_ENV[$key];
        }
        return null;
    }
}

if (! function_exists('flash')) {
    function flash(): FlashMessage
    {
        return FlashMessage::instance();
    }
}

if (! function_exists('controller')) {
    function controller($middleware = []): Controller
    {
        return Controller::getInstance($middleware);
    }
}

if (! function_exists('redirect')) {
    function redirect($url, $permanent = false)
    {
        $url = str_replace('Location: ', '', $url);
        header('Location: ' . $url, true, $permanent ? 301 : 302);
        exit;
    }
}